#ifndef __IOCTL_H_INCLUDED__
#define __IOCTL_H_INCLUDED__

#include "ioctl_types.h"

#include <linux/types.h>
#include <asm/ioctl.h>

#define GRAID_IOCTL_TYPE          0xCD

/* Supported operations */
enum graid_ioctl_type
{
	GRAID_GET_DMA_POOL	= _IOR(GRAID_IOCTL_TYPE, 1, struct GRAID_DMA_Pool),
	GRAID_GET_NR_CPUS	= _IOR(GRAID_IOCTL_TYPE, 2, unsigned long),

	GRAID_DMA_GET_PRE_ALLOC	= _IOR(GRAID_IOCTL_TYPE, 3, unsigned long),
	GRAID_DMA_SET_BAR1	= _IOW(GRAID_IOCTL_TYPE, 4, unsigned long),
	GRAID_DMA_RESET_BAR1	= _IOW(GRAID_IOCTL_TYPE, 5, unsigned long),

	GRAID_PCI_QUERY_NVME	= _IOWR(GRAID_IOCTL_TYPE, 12, struct graid_pci_nvme_dev),
	GRAID_PCI_RESET_NVME	= _IOW(GRAID_IOCTL_TYPE, 15, unsigned long),
	GRAID_PCI_ALLOC_ID	= _IOR(GRAID_IOCTL_TYPE, 16, unsigned long),
	GRAID_PCI_FREE_ID	= _IOW(GRAID_IOCTL_TYPE, 17, unsigned long),
	GRAID_PCI_DEALLOC_NVME	= _IOW(GRAID_IOCTL_TYPE, 18, unsigned long),

	GRAID_DG_CREATE		= _IOW(GRAID_IOCTL_TYPE, 21, unsigned long),
	GRAID_DG_DESTROY	= _IOW(GRAID_IOCTL_TYPE, 22, unsigned long),

	GRAID_VIR_NVME_CREATE	= _IOW(GRAID_IOCTL_TYPE, 31, struct graid_virt_nvme_dev),
	GRAID_VIR_NVME_DESTROY	= _IOW(GRAID_IOCTL_TYPE, 32, unsigned long),
	GRAID_VIR_NVME_RESUME	= _IOW(GRAID_IOCTL_TYPE, 33, unsigned long),
	GRAID_VIR_NVME_PAUSE	= _IOW(GRAID_IOCTL_TYPE, 34, unsigned long),
	GRAID_VIR_NVME_CHECK	= _IOW(GRAID_IOCTL_TYPE, 35, unsigned long),

	GRAID_BLK_CREATE	= _IOWR(GRAID_IOCTL_TYPE, 41, struct graid_blk_dev_param),
	GRAID_BLK_DESTROY	=  _IOW(GRAID_IOCTL_TYPE, 42, unsigned long),
	GRAID_BLK_RESET		=  _IOW(GRAID_IOCTL_TYPE, 43, unsigned long),

	GRAID_GPU_PIN_BAR1	= _IOWR(GRAID_IOCTL_TYPE, 51, struct graid_gpu_bar1_req),
	GRAID_GPU_UNPIN_BAR1	=  _IOW(GRAID_IOCTL_TYPE, 52, struct graid_gpu_bar1_req),

	GRAID_CLEAN_SHUTDOWN	=  _IOW(GRAID_IOCTL_TYPE, 60, unsigned long),
};

#endif
