// -*- mode:c; tab-width:8; c-basic-offset:8; indent-tabs-mode:t -*-
// vim: ts=8 sw=8 smarttab
#ifndef __VIRTUAL_NVME_H_INCLUDED__
#define __VIRTUAL_NVME_H_INCLUDED__

#define GRAID_INIT_POLL_TIME		50
#define GRAID_MAX_POLL_TIME		100
#define GRAID_MIN_POLL_TIME		10
#define GRAID_POLL_TIME_STEP		10
#define GRAID_POST_POLL_TIME		(5 * 1000 * 1000)
#define GRAID_MAX_SAME_POLL_STAT	4
#define GRAID_POLL_STAT_MASK		((1 << GRAID_MAX_SAME_POLL_STAT) - 1)

#define GRAID_POLL_STOP		0
#define GRAID_POLL_HIT		1
#define GRAID_POLL_MISS		2

// NVME_ID_CNS_NS
const struct nvme_id_ns graid_id_ns_data = {
	.nsze 		= cpu_to_le64(703277316),
	.ncap 		= cpu_to_le64(703277316),
	.nuse 		= cpu_to_le64(703277316),
	.nsfeat 	= 1u << 4, /* OPTPERF fields defined */
	.nlbaf 		= 0,
	.flbas 		= 0,
	.mc		= 0,
	.dpc		= 0,
	.dps		= 0,
	.nmic		= 0,
	.rescap		= 0,
	.fpi		= 0,
	.dlfeat		= 0,
	.nawun 		= cpu_to_le16(0),
	.nawupf		= cpu_to_le16(0),
	.nacwu		= cpu_to_le16(0),
	.nabsn		= cpu_to_le16(0),
	.nabo		= cpu_to_le16(0),
	.nabspf		= cpu_to_le16(0),
	.noiob		= cpu_to_le16(0),
	.nvmcap		= {0},
	.npwg		= cpu_to_le16(0),
	.npwa		= cpu_to_le16(0),
	.npdg		= cpu_to_le16(0),
	.npda		= cpu_to_le16(0),
	.nows		= cpu_to_le16(0),
	.rsvd74 	= {0},
	.anagrpid 	= cpu_to_le32(0),
	.rsvd96		= {0},
	.nsattr		= 0,
	.nvmsetid	= cpu_to_le16(0),
	.endgid		= cpu_to_le16(0),
	.nguid		= {0},
	.eui64		= {0},
	.lbaf		= {{.ms=cpu_to_le16(0),
			    .ds=12,
			    .rp=0,},
			   {0},{0},{0},{0},{0},{0},{0},{0},{0},{0},{0},{0},{0},{0},{0}},
	.rsvd192	= {0},
	.vs		= {0},
};

// NVME_ID_CNS_CTRL
const struct nvme_id_ctrl graid_id_ctrl_data = {
	.vid		= cpu_to_le16(0x651D),
	.ssvid		= cpu_to_le16(0x651D),
	.sn		= "GRAID-SN",
	.mn		= "GRAID-MN",
	.fr		= "GRAID-FR",
	.rab		= 0,
	.ieee		= {0x5c, 0xd2, 0xe4},
	.cmic		= 0,
	.mdts		= 5,
	.cntlid		= cpu_to_le16(0),
	.ver		= cpu_to_le32(0),
	.rtd3r		= cpu_to_le32(0),
	.rtd3e		= cpu_to_le32(0),
	.oaes		= cpu_to_le32(0),
	.ctratt		= cpu_to_le32(0),
	.rsvd100	= {0},
	.crdt1		= cpu_to_le16(0),
	.crdt2		= cpu_to_le16(0),
	.crdt3		= cpu_to_le16(0),
	.rsvd134	= {0},
	.oacs		= cpu_to_le16(0),
	.acl		= 0x03,
	.aerl		= 0x03,
	.frmw		= 0x02,
	.lpa		= 0,
	.elpe		= 0x3F,
	.npss		= 0,
	.avscc		= 0,
	.apsta		= 0,
	.wctemp		= cpu_to_le16(0),
	.cctemp		= cpu_to_le16(0),
	.mtfa		= cpu_to_le16(0),
	.hmpre		= cpu_to_le32(0),
	.hmmin		= cpu_to_le32(0),
	.tnvmcap	= {0},
	.unvmcap	= {0},
	.rpmbs		= cpu_to_le32(0),
	.edstt		= cpu_to_le16(0),
	.dsto		= 0,
	.fwug		= 0,
	.kas		= cpu_to_le16(0),
	.hctma		= cpu_to_le16(0),
	.mntmt		= cpu_to_le16(0),
	.mxtmt		= cpu_to_le16(0),
	.sanicap	= cpu_to_le32(0),
	.hmminds	= cpu_to_le32(0),
	.hmmaxd		= cpu_to_le16(0),
	.rsvd338	= {0},
	.anatt		= 0,
	.anacap		= 0,
	.anagrpmax	= cpu_to_le32(0),
	.nanagrpid	= cpu_to_le32(0),
	.rsvd352	= {0},
	.sqes		= 0x66,
	.cqes		= 0x44,
	.maxcmd		= cpu_to_le16(0),
	.nn		= cpu_to_le32(1),
	.oncs		= cpu_to_le16(0),
	.fuses		= cpu_to_le16(0),
	.fna		= 0x02,
	.vwc		= 0x02,
	.awun		= cpu_to_le16(0),
	.awupf		= cpu_to_le16(0),
	.nvscc		= 0,
	.nwpc		= 0,
	.acwu		= cpu_to_le16(0),
	.rsvd534	= {0},
	.sgls		= cpu_to_le32(0),
	.mnan		= cpu_to_le32(0),
	.rsvd544	= {0},
	.subnqn		= "GRAID-SUBNQN",
	.rsvd1024	= {0},
	.ioccsz		= cpu_to_le32(0),
	.iorcsz		= cpu_to_le32(0),
	.icdoff		= cpu_to_le16(0),
	.ctrattr	= 0,
	.msdbd		= 0,
	.rsvd1804	= {0},
	.psd		= {{0}},
	.vs		= {0},
};

// NVME_ID_CNS_NS_ACTIVE_LIST
const u32 graid_id_ns_active_data[1024] = {
	[0] = cpu_to_le32(1),
};

// NVME_ID_CNS_NS_DESC_LIST
struct graid_id_ns_desc {
	struct nvme_ns_id_desc ns_id_desc_1;
	struct nvme_ns_id_desc rsvd[1023];
};

const struct graid_id_ns_desc graid_id_ns_desc_data = {
	.ns_id_desc_1 = {
		.nidt = NVME_NIDT_NGUID,
		.nidl = NVME_NIDT_NGUID_LEN,
		.reserved = cpu_to_le16(0),
	},
	.rsvd = {{0}},
};
#endif
